Python3入门(十二)错误和异常 – 阿靖哦

Python publisher01 26℃ 0评论

学习 Python 编程时,经常会看到一些报错信息,在前面我们没有提及,这章节我们会专门介绍。Python 有两种错误很容易辨认:语法错误和异常

一、语法错误

语法错误也可以称之为解析错误,如下

if True
    print("ok")

会出现错误,因为if条件后没有加:

二、异常

即便Python程序的语法是正确的,在运行它的时候,也有可能发生错误。运行期检测到的错误被称为异常,大多的异常都不会被程序所处理,都是抛出异常信息

a = int("你好")

会出现如下异常

Traceback (most recent call last):
  File "/Users/colin/PycharmProjects/demo/ex/TestError.py", line 4, in <module>
    a = int("你好")
ValueError: invalid literal for int() with base 10: '你好'

三、异常处理

以下案例为用户中断程序会抛出异常

while True:
    try:
        num = int(input("Please input a number: "))
        break
    except ValueError:
        print("Your input number is not valid, Try again")

以上实例中,当用户输入一个非数字的时候,会发出异常,如果发出的异常与except后的相符,此时会执行except的语句,如果没有出现异常或者异常不相符,则不会执行,一个except可以同时处理多个异常,通常放到()里,变成一个元组
except(RuntimeError, TypeError)
最后一个except语句可以不指定异常的名称,raise关键字显示引发异常的方法

try:
    print(int("hello"))
except RuntimeError:
    print("Value error")
except:
    print("Other error")
    raise

try..except语句还可以有一个else语句,如果使用这个语句,必须放在所有except之后,这个语句将在try语句没有发生任何情况下执行

try:
    print(int("1"))
except RuntimeError:
    print("Value error")
except:
    print("Other error")
    raise
else:
    print("ok")

使用else子句比把所有的语句都放在try子句里面要好,这样可以避免一些意想不到的、而except又没有捕获的异常

四、抛出异常

使用raise语句抛出一个指定的异常

print(1)
raise ValueError("试试异常")

raise唯一的一个参数指定了要被抛出的异常信息。它必须是一个异常的实例或者是异常的类(也就是 Exception 的子类)。如果你只想知道这是否抛出了一个异常,并不想去处理它,那么一个简单的raise语句就可以再次把它抛出

五、自定义异常

通过创建一个新的异常类来拥有自己的异常。异常类继承自 Exception 类,可以直接继承,或者间接继承,这个例子中,类Exceptio默认的__init__()被覆盖

class MyError(Exception):
    def __init__(self, value):
        self.value = value
    def __str__(self):
        return repr(self.value)
try:
    raise MyError("自己的异常")
except MyError as e:
    print(e.value)

六、定义清理行为

try语句还有另外一个可选的子句,它定义了无论在任何情况下都会执行的清理行为,不管try子句里面有没有发生异常,finally子句都会执行

try:
    raise KeyboardInterrupt
finally:
    print("执行清理")

七、预定义的清理行为

一些对象定义了标准的清理行为,无论系统是否成功的使用了它,一旦不需要它了,那么这个标准的清理行为就会执行

for i in open("/Users/colin/PycharmProjects/demo/Test.txt"):
    print(i)

以上代码在读取完文件后,文件会一直保持打开状态,没有被关闭,如果想要使用完后一定会执行清理,可以修改为如下:

with open("/Users/colin/PycharmProjects/demo/Test.txt") as f:
    for i in f:
        print(i)

本文到此结束,如果发现有误可以在下方评论区留言哦

© 著作权归作者所有,转载或内容合作请联系作者

你或许想:《去原作者写文章的地方

转载请注明:Python量化投资 » Python3入门(十二)错误和异常 – 阿靖哦

喜欢 (0)or分享 (0)
发表我的评论
取消评论
表情

Hi,您需要填写昵称和邮箱!

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址